routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\FacturaController;
use App\Http\Controllers\ClienteController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\TipoFacturacionController;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

//Auth::routes();

//Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::middleware(['auth:sanctum', 'verified'])->get('/home', function () {
    return view('home');
})->name('home');
Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

//se define las rutas para el controlador de Facturas:
Route::resource('facturas', FacturaController::class);
Route::resource('clientes', ClienteController::class);
Route::resource('productos', ProductoController::class);
Route::resource('tipo_facturacion', TipoFacturacionController::class);

Route::get('factura/precio', [FacturaController::class, 'getPrecioProducto'])->name('factura.precio');


//se definen las rutas para el controlador de clientes
Route::get('/clientes', [ClienteController::class, 'index'])->name('clientes.index');
Route::get('/clientes/create', [ClienteController::class, 'create'])->name('clientes.create');
Route::post('/clientes', [ClienteController::class, 'store'])->name('clientes.store');
Route::get('/clientes/{id}', [ClienteController::class, 'show'])->name('clientes.show');
Route::get('/clientes/{id}/edit', [ClienteController::class, 'edit'])->name('clientes.edit');
Route::put('/clientes/{id}', [ClienteController::class, 'update'])->name('clientes.update');
Route::delete('/clientes/{id}', [ClienteController::class, 'destroy'])->name('clientes.destroy');

//se definen las rutas para el controlador de productos
/*
Route::get('/productos', [ProductoController::class, 'index'])->name('productos.index');
Route::get('/productos/crear', [ProductoController::class, 'create'])->name('productos.create');
Route::post('/productos', [ProductoController::class, 'store'])->name('productos.store');
Route::get('/productos/{id}/editar', [ProductoController::class, 'edit'])->name('productos.edit');
Route::put('/productos/{id}', [ProductoController::class, 'update'])->name('productos.update');
Route::delete('/productos/{id}', [ProductoController::class, 'destroy'])->name('productos.destroy');
*/

app/Models/Factura.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Factura extends Model
{
    use HasFactory;

    public $timestamps = false;
    protected $table = 'formulas';

    protected $fillable = [
        'id_usuario',
        'id_cliente',
        'fecha_venta',
        'id_tipo_facturacion',
        'subtotal',
        'descuento',
        'total',
    ];

    public function user()
    {
        return $this->belongsTo(User::class, 'id_usuario');
    }

    public function cliente()
    {
        return $this->belongsTo(Cliente::class, 'id_cliente');
    }

    public function tipoFacturacion()
    {
        return $this->belongsTo(TipoFacturacion::class, 'id_tipo_facturacion');
    }

    public function facturaLineas()
    {
        return $this->hasMany(FactuLinea::class, 'id_formula');
    }
}

app/Http/Controllers/FacturaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Cliente;
use App\Models\Factulinea;
use App\Models\Factura;
use App\Models\Producto;
use App\Models\TipoFacturacion;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

ini_set('memory_limit', '2G'); // aumentar el límite de memoria a 1 GB

class FacturaController extends Controller
{

    public function index()
    {
        $facturas = Factura::all();
        return view('facturas.index', compact('facturas'));
    }
    public function create()
    {
        $clientes = Cliente::all();
        $productos = Producto::all();
        $tipoFacturacion = TipoFacturacion::all();

        return view('facturas.create', compact('clientes', 'productos', 'tipoFacturacion'));
    }

    public function store(Request $request)
    {
        /*
        $factura = new Factura;
        $factura->fecha = $request->fecha;
        $factura->cliente_id = $request->cliente_id;
        $factura->tipo_facturacion_id = $request->tipo_facturacion_id;
        $factura->save();

        foreach ($request->producto_id as $key => $producto_id) {
            $facturaLinea = new Factulinea();
            $facturaLinea->factura_id = $factura->id;
            $facturaLinea->producto_id = $producto_id;
            $facturaLinea->cantidad = $request->cantidad[$key];
            $facturaLinea->precio = $request->precio[$key];
            $facturaLinea->save();
        }

        return redirect()->route('facturas.index');*/

        $usuario_id = Auth::user()->id;

        $cantidad = $request->cantidad;
        $subtotal = $request->subtotal;
        echo "request";
        
        $factura = new Factura;
        $factura->id_cliente = $request->cliente_id;
        $factura->fecha_venta = now(); //date('Y-m-d');
        $factura->id_tipo_facturacion = $request->tipo_facturacion;
        //$factura->observacion = $request->observacion;
        $factura->id_usuario = $usuario_id;
        $factura->total = $request->total;
        $factura->save();

        $factura_id = $factura->id;

        $productos = $request->producto_id;
        foreach ($productos as $key => $producto) {
            //print_r($producto);die();
            $producto_id = $producto;
            $cantidad = $request->cantidad[$key];
            $subtotal = $request->subtotal[$key];
            //$cantidad = $producto['cantidad'];
            //$lote = $producto['lote'];
            //$vencimiento = $producto['vencimiento'];
            //print_r(intval($cantidad));die();
            //$vencimiento = $producto['vencimiento'];
            $producto = Producto::find($producto_id);

            $facturaLinea = new FactuLinea;
            $facturaLinea->id_formula = $factura_id;
            $facturaLinea->id_producto = $producto_id;
            $facturaLinea->cantidad = $cantidad; //$request->cantidad;
            $facturaLinea->precio = $producto->precio;
            $facturaLinea->total_linea = $subtotal;
            $facturaLinea->save();
        }
        //dd($producto);
        //print_r($producto);die();
        return redirect()->route('facturas.index');
    }


    public function edit($id)
    {
        $factura = Factura::findOrFail($id);
        $clientes = Cliente::all();
        $tiposFacturacion = TipoFacturacion::all();
        $productos = Producto::all();
        $factuLinea = FactuLinea::where('id_formula', $factura->id)->get();
        //dd($factura);
        return view('facturas.edit', compact('factura', 'clientes', 'tiposFacturacion', 'productos', 'factuLinea'));
    }


    public function update(Request $request, $id)
    {
        $factura = Factura::findOrFail($id);
        $factura->id_cliente = $request->cliente_id;
        $factura->fecha_venta = now();
        $factura->id_tipo_facturacion = $request->tipo_facturacion;
        $factura->total = $request->total;
        $factura->save();

        //dd(intval($request->cantidad));
        $facturaLineas = FactuLinea::where('id_formula', $factura->id)->get();
        $productos = $request->producto_id;

        // Eliminar las factulineas que ya no están en el formulario
        foreach ($facturaLineas as $facturaLinea) {
            if (!in_array($facturaLinea->id_producto, $productos)) {
                $facturaLinea->delete();
            }
        }

        // Agregar o actualizar las factulineas del formulario
        foreach ($productos as $key => $producto) {
            $producto_id = $producto;
            $cantidad = $request->cantidad[$key]; // Obtener la cantidad correspondiente al producto
            $producto = Producto::find($producto_id);
            $precio = $producto->precio;
        
            $facturaLinea = $factura->facturaLineas()->updateOrCreate(
                ['id_producto' => $producto_id],
                ['cantidad' => $cantidad, 'precio' => $precio, 'subtotal' => $precio * intval($cantidad), 'total_linea' => $request->total]
            );
        }

        

        return redirect()->route('facturas.index');
    }


    public function destroy(Factura $factura)
    {

        $facturaLineas = FactuLinea::where('id_formula', $factura->id)->get();
        foreach ($facturaLineas as $facturaLinea) {
            $facturaLinea->delete();
        }
        $factura->delete();

        return redirect()->route('facturas.index');
    }

    /*public function getPrecioProducto(Request $request)
    {
        echo "hola" . $request->input('producto_id');
        die();
        $producto = Producto::find($request->input('producto_id'));
        return response()->json(['precio' => $producto->precio]);
    }*/

    public function show(Factura $factura)
    {
        $factuLinea = FactuLinea::where('id_formula', $factura->id)->get();
        $productos = Producto::all();
        return view('facturas.show', compact('factura', 'factuLinea', 'productos'));
    }
}

resources/views/facturas/create.blade.php
@extends('adminlte::page')

@section('title', 'Facturas')

@section('content_header')
    <h1>Nueva Factura</h1>
@stop

@section('content')

    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <form action="{{ route('facturas.store') }}" method="POST">
                    @csrf
                    <div class="form-group">
                        <label for="cliente_id">Cliente:</label>
                        <select name="cliente_id" id="cliente_id" class="form-control cliente_id" onchange="updateEps(this)">
                            @foreach ($clientes as $cliente)
                                <option value="{{ $cliente->id }}">{{ $cliente->cedula }} - {{ $cliente->nombre }}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="eps">EPS:</label>
                        <input type="text" name="eps" id="eps" class="form-control"
                            value="{{ old('eps') }}">
                    </div>
                    <div class="form-group">
                        <label for="fecha">Fecha:</label>
                        <input type="date" name="fecha" id="fecha" class="form-control"
                            value="{{ old('fecha', date('Y-m-d')) }}">
                    </div>
                    <div class="form-group col-md-6">
                        <label for="tipo_facturacion">Tipo de Facturación:</label>
                        <select name="tipo_facturacion" class="form-control" required>
                            <option value="" disabled selected>Selecciona un tipo de facturación</option>
                            @foreach ($tipoFacturacion as $tf)
                                <option value="{{ $tf->id }}">{{ $tf->descripcion }}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="observacion">Observación:</label>
                        <textarea name="observacion" id="observacion" class="form-control">{{ old('observacion') }}</textarea>
                    </div>
                    <div class="form-group">
                        <label for="usuario_id">Usuario:</label>
                        <input type="text" name="usuario_id" id="usuario_id" class="form-control"
                            value="{{ auth()->user()->name }}" readonly>
                    </div>


                    <label for="detalle_fac">Detalle Factura:</label>

                    <table class="table products-table" id="products-table">
                        <thead>
                            <tr>
                                <th>Producto</th>
                                <th>Cantidad</th>
                                <th>Lote</th>
                                <th>Vencimiento</th>
                                <th>Precio</th>
                                <th>Subtotal</th>
                                <th>Acciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr class="fila-producto">
                                <td>
                                    <select class="form-control product-select" name="producto_id[]"
                                        onchange="updatePrice(this)">
                                        <option value="">Seleccione un producto</option>
                                        @foreach ($productos as $product)
                                            <option value="{{ $product->id }}">{{ $product->id }} -
                                                {{ $product->nombre_producto }}</option>
                                        @endforeach
                                    </select>
                                </td>
                                <td><input type="number" class="form-control cantidad-producto" name="cantidad[]"
                                        id="cantidad[]" min="1" value="0" onchange="calcularSubtotal(this)">
                                </td>
                                <td><input type="text" class="form-control" name="lote[]"></td>
                                <td><input type="date" class="form-control" name="vencimiento[]"></td>
                                <td><input type="text" class="form-control product-price" id="precio[]" id="precio[]"
                                        readonly></td>
                                <td><input type="text" class="form-control product-subtotal" id="subtotal[]"
                                        name="subtotal[]" readonly>
                                </td>

                                <td><button type="button" class="btn btn-danger btn-sm delete-row"><i
                                            class="fas fa-trash-alt"></i></button></td>
                            </tr>
                        </tbody>
                    </table>
                    <div class="form-group">
                        <button type="button" class="btn btn-success btn-sm" id="add-row"><i class="fas fa-plus"></i>
                            Agregar Producto</button>
                    </div>
                    <div class="form-group">
                        <div class="input-group">
                            <div class="input-group-prepend">
                                <button class="btn btn-primary" type="button" id="calcular-total">Calcular total</button>
                            </div>
                            <input type="number" class="form-control text-right font-weight-bold" name="total"
                                id="total" readonly>
                        </div>
                    </div>

                    <div class="form-group text-center">
                        <button type="submit" class="btn btn-primary">Guardar</button>
                        <a href="{{ route('facturas.index') }}" class="btn btn-secondary">Cancelar</a>
                    </div>
                </form>
            </div>
        </div>

    </div>
    </div>
@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
    <link href="https://cdn.datatables.net/1.10.22/css/daaTables.bootstrap5.min.css" rel="stylesheet">
@stop

@section('js')
    <script>
        function updatePrice(select) {
            document.getElementById("total").setAttribute("required", "required");
            const index = Array.from(select.parentNode.parentNode.children).indexOf(select.parentNode);
            let precio = {{ $productos[0]->precio }};
            let lote = '';
            let vencimiento = '';

            //let cantidad = select.parentNode.parentNode.children[4].children[0].value;

            const producto = {!! $productos !!}.find(p => p.id == select.value);
            if (producto) {
                precio = producto.precio;
                lote = producto.lote;
                vencimiento = producto.vencimiento;

                ////console.log(cantidad);
                select.parentNode.parentNode.children[4].children[0].value = precio;
                select.parentNode.parentNode.children[3].children[0].value = vencimiento;
                select.parentNode.parentNode.children[2].children[0].value = lote;
                cantidad = select.parentNode.parentNode.children[1].children[0].value;
                //let subtotal = precio * cantidad;
                //select.parentNode.parentNode.children[5].children[0].value = subtotal;
                //$('.product-price').val(precio);

            }
            //select.parentNode.parentNode.children[4].children[0].value = precio;
        }

        function calcularSubtotal(select) {
            select.parentNode.parentNode.children[5].children[0].value = '';
            //var total = 0;
            var subtotal = 0;
            const index = Array.from(select.parentNode.parentNode.children).indexOf(select.parentNode);
            let precio = select.parentNode.parentNode.children[4].children[0].value;
            cantidad = select.parentNode.parentNode.children[1].children[0].value;
            console.log(precio);
            const producto = {!! $productos !!}.find(p => p.id == select.value);
            if (producto) {
                //precio = producto.precio;

                subtotal = cantidad * precio;
                console.log(cantidad);

                console.log(subtotal);

            }
            select.parentNode.parentNode.children[5].children[0].value = subtotal;


            //total += subtotal;
            //console.log(total);
            // $('#total').val(total);
        }


        function updateEps(select) {
            const index = Array.from(select.parentNode.parentNode.children).indexOf(select.parentNode);
            const producto = {!! $productos !!}.find(p => p.id == select.value);
            const cliente = {!! $clientes !!}.find(p => p.id == select.value);

            let eps = cliente.eps;
            //console.log(index);
            console.log(cliente.eps);
            $('#eps').val(eps);
        }


        $(document).ready(function() {

            // calcular subtotal al cambiar el producto o la cantidad
            /*$('.cantidad-producto, .product-subtotal').change(function() {
                var row = $(this).closest('tr');
                var precio = parseFloat(row.find('.product-price').val());
                var cantidad = parseInt(row.find('.cantidad-producto').val());
                var subtotal = precio * cantidad;
                row.find('.product-subtotal').text('$ ' + subtotal.toFixed(2));
            });*/

            $('#calcular-total').on('click', function() {
                var total = 0;
                // Iterar sobre los campos de cantidad de productos y sumar el total
                $('.cantidad-producto').each(function() {
                    var cantidad = parseInt($(this).val());
                    var precio = parseFloat($(this).closest('tr').find('.product-price').val());
                    var subtotal = cantidad * precio;
                    total += subtotal;
                });
                // Actualizar el campo de total
                $('#total').val(total.toFixed(0));


            });


            /* WORKS!
                        function actualizarTotal() {
                            var total = 0;
                            $('.fila-producto').each(function() {
                                console.log("entra")
                                var cantidad = parseInt($(this).find('.cantidad-producto').val());
                                var precio = parseInt($(this).find('.product-price').val());
                                var subtotal = cantidad * precio;
                                total += subtotal;
                            });
                            $('#total').val(total.toFixed(0));
                        }

                        // Escuchar cambios en los campos de cantidad y precio de los productos
                        $('.cantidad-producto, .product-subtotal').on('change', function() {
                            console.log("emtraa")
                            actualizarTotal();
                        });
            */
            // Manejar el evento de agregar filas
            $('#add-row').click(function() {
                var row = $('#products-table tbody tr:last').clone();
                row.find('select,input').val('');
                $('#products-table tbody').append(row);
            });

            // Manejar el evento de eliminar filas
            $(document).on('click', '.delete-row', function() {
                $(this).closest('tr').remove();
            });
        });

        $('form').on('submit', function(e) {
            if ($('#total').val() == '') {
                e.preventDefault(); // Evita que el formulario se envíe si el campo está vacío
                alert(
                'Por favor presione el botón "Calcular el total" antes de guardar.'); // Muestra un mensaje de alerta al usuario
            }
        });
    </script>

@stop

resources/views/facturas/edit.blade.php
@extends('adminlte::page')

@section('title', 'Facturas')

@section('content_header')
    <h1>Editar Factura</h1>
@stop

@section('content')
    <div class="container">
        <form action="{{ route('facturas.update', $factura->id) }}" method="POST">
            @csrf
            @method('PUT')
            <div class="form-group">
                <label for="fecha">Fecha:</label>
                <input type="date" class="form-control" id="fecha" name="fecha"
                    value="{{ date('Y-m-d', strtotime($factura->fecha_venta)) }}">
            </div>
            <div class="form-group">
                <label for="cliente_id">Cliente:</label>
                <select class="form-control" id="cliente_id" name="cliente_id">
                    @foreach ($clientes as $cliente)
                        <option value="{{ $cliente->id }}" {{ $cliente->id == $factura->cliente_id ? 'selected' : '' }}>
                            {{ $cliente->nombre }}
                        </option>
                    @endforeach
                </select>
            </div>
            <div class="form-group">
                <label for="tipo_facturacion">Tipo de facturación:</label>
                <select class="form-control" id="tipo_facturacion" name="tipo_facturacion">
                    @foreach ($tiposFacturacion as $tipoFacturacion)
                        <option value="{{ $tipoFacturacion->id }}"
                            {{ $tipoFacturacion->id == $factura->tipo_facturacion_id ? 'selected' : '' }}>
                            {{ $tipoFacturacion->descripcion }}
                        </option>
                    @endforeach
                </select>
            </div>
            <div class="form-group">
                <label for="total">Total:</label>
                <input type="number" class="form-control" id="total" name="total" value="{{ $factura->total }}">
            </div>
            <div class="form-group productos-container" id="productos">
                <label for="productos">Productos:</label>
                @foreach ($factuLinea as $linea)
                    <div class="form-row producto-fila">
                        <div class="col">
                            <select class="form-control producto-selector" id="producto_id" name="producto_id[]">
                                @foreach ($productos as $producto)
                                    <option value="{{ $producto->id }}"
                                        {{ $producto->id == $linea->id_producto ? 'selected' : '' }}>
                                        {{ $producto->nombre_producto }}
                                    </option>
                                @endforeach
                            </select>
                        </div>
                        <div class="col">
                            <input type="number" class="form-control cantidad-input" id="cantidad" name="cantidad[]"
                                value="{{ $linea->cantidad }}">
                        </div>
                        <div class="col">
                            <input type="number" class="form-control precio-input" id="precio" name="precio[]"
                                value="{{ $linea->precio }}">
                        </div>
                        <div class="col">
                            <input type="number" class="form-control subtotal" name="subtotal[]" readonly>
                        </div>
                    </div>
                @endforeach
            </div>
            <div class="form-group">
                <button type="button" class="btn btn-success btn-sm" id="add-row"><i class="fas fa-plus"></i> Agregar
                    Producto</button>

            </div>
            <div class="form-group">
                <div class="input-group">
                    <div class="input-group-prepend">
                        <button class="btn btn-primary" type="button" id="calcular-total">Calcular total</button>
                    </div>
                    <input type="number" class="form-control text-right font-weight-bold" name="total" id="total"
                        readonly>
                </div>
            </div>
            <button type="submit" class="btn btn-primary">Guardar cambios</button>
        </form>
    </div>
@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
@stop

@section('js')
    <script>
        var productos = {!! json_encode($productos) !!};
        $(document).ready(function() {

            $(document).on('change', '.producto-selector', function() {
                var productoId = $(this).val();
                var precioInput = $(this).closest('.form-row').find('.precio-input');
                var precioProducto = productos.find(p => p.id == productoId).precio;
                precioInput.val(precioProducto);
            });


            // calcular subtotal al cambiar el producto o la cantidad
            /*$('.cantidad-producto, .product-subtotal').change(function() {
                var row = $(this).closest('tr');
                var precio = parseFloat(row.find('.product-price').val());
                var cantidad = parseInt(row.find('.cantidad-producto').val());
                var subtotal = precio * cantidad;
                row.find('.product-subtotal').text('$ ' + subtotal.toFixed(2));
            });*/

            $('#calcular-total').click(function() {
                var total = 0;
                $('#productos .form-row').each(function() {
                    var cantidad = $(this).find('[name="cantidad[]"]').val();
                    var precio = $(this).find('[name="precio[]"]').val();
                    var subtotal = cantidad * precio;
                    total += subtotal;
                });
                $('[name="total"]').val(total);
            });


            // Manejar el evento de agregar filas
            $('#add-row').click(function() {
                var fila = $('#productos .form-row:first').clone();
                fila.find('input').val('');
                fila.find('select').prop('selectedIndex', 0);
                $('#productos').append(fila);
            });


            // Manejar el evento de eliminar filas
            $(document).on('click', '.delete-row', function() {
                $(this).closest('tr').remove();
            });

            // Escuchar el evento change de los campos de cantidad y precio de cada producto
            $(document).on('change', '.cantidad-input, .precio-input', function() {
                var cantidad = $(this).closest('.form-row').find('.cantidad-input').val();
                var precio = $(this).closest('.form-row').find('.precio-input').val();
                var subtotal = cantidad * precio;
                $(this).closest('.form-row').find('.subtotal').val(subtotal);
                var total = 0;
                $('.subtotal').each(function() {
                    total += parseInt($(this).val());
                });
                $('[name="total"]').val(total);
            });
        });
    </script>
@stop

resources/views/facturas/show.blade.php
@extends('adminlte::page')

@section('title', 'Factura')

@section('content_header')
    <h1>Detalle Factura</h1>
@stop

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-8 col-md-offset-2">
                <div class="panel panel-default">
                    
                    <div class="panel-body">
                        <p><strong>Número de factura:</strong> Factura {{ $factura->id }}</p>
                        <p><strong>Fecha de emisión:</strong> {{ $factura->fecha_venta }}</p>
                        <p><strong>Total:</strong> {{ $factura->total }}</p>
                        <p><strong>Cliente:</strong> {{ $factura->cliente->nombre }}</p>
                        <p><strong>Productos:</strong></p>
                        <ul>
                            @foreach ($factuLinea as $producto)
                            
                                <li><strong>Código:</strong> {{ $producto->id_producto }} - <strong>Precio:</strong> {{ $producto->precio }}</li>
                            
                            @endforeach
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>
@stop